
% CCRMA MIR Workshop 2009
% Lab4: Data preprocessing - LDA (Linear Discriminant Analysis)
% Kyogu Lee (June 2009)

clear all;
close all;

% load feature data and labels
load('ftrslabs.mat');

% LDA pre-processing
ndim = 1; % LDA dimension is (nclass - 1)
data.X = ftrs';
data.y = labs;
lda_model = lda(data, ndim);
data_lda = linproj(data, lda_model);
lda_rec = pcarec(data.X, lda_model);

% display data before/after LDA
figure;
ppatterns(data); hold on;
figure;
ppatterns(data_lda);

% train GMMs using original data
[M0,M1] = traingmms(ftrs(:,1:3), labs, 5);

% now train GMMs using LDA-transformed data
[M0,M1] = traingmms(data_lda.X', labs, 5);
